{******************************************************}
{                                                      }
{    Copyright  2007, Naumenko Anton Aka Antonn.      }
{                http://desksoft.ru                    }
{                   29.11.2007                         }
{                                                      }
{******************************************************}
unit screeeeen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls;

type
  TFormScreen = class(TForm)
    bclose: TButton;
    bsave: TButton;
    SD: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure bcloseClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bsaveClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    _shot:boolean; isMouseDown,draww,redr:boolean; ree:trect;
    BT,BT_tmp:Tbitmap;  ix,iy:integer;
    procedure DrawBack;
  public
    procedure Shotting;
  end;

var
  FormScreen: TFormScreen;

implementation

{$R *.dfm}

function InRect(x,y,left,top,right,down:integer):boolean;
begin
  if(x>left)and(x<right)and(y>top)and(y<down) then
    InRect:=true
  else
    InRect:=false;
end;

function IsButtOn:Boolean;
begin
  Result:=0<>(GetKeyState(VK_SHIFT)and 128);
end;

procedure DrawVisor(_B_in:TBitmap; rect:trect);
const
  MaxPixelCountA = MaxInt div SizeOf(TRGBQuad);
type
  PRGBAArray = ^TRGBAArray;
  TRGBAArray = array[0..MaxPixelCountA-1] of TRGBQuad;
var i,ii,ix,iy,CenterPointY,CenterPointX:integer;
     RowOut: PRGBAArray;
begin
_B_in.Canvas.Pen.Width:=1;
_B_in.Canvas.Pen.Color:=rgb(0,20,0);
CenterPointX:=rect.Left+((rect.Right-rect.Left) div 2);
CenterPointY:=rect.Top+((rect.Bottom-rect.Top) div 2);
ix:=CenterPointX-(CenterPointX div 24)*24;
iy:=CenterPointY-(CenterPointY div 24)*24;
for i:=rect.Top to rect.Bottom-1 do  begin
  RowOut:=_B_in.ScanLine[i];
  for ii:=rect.Left to rect.Right-1 do begin
   if ((ii=(ii div 24)*24+ix))or((i=(i div 24)*24+iy)) then begin
    RowOut[ii].rgbBlue:=trunc(RowOut[ii].rgbBlue*0.8);
    RowOut[ii].rgbGreen:=trunc(RowOut[ii].rgbGreen*0.8);
    RowOut[ii].rgbRed:=trunc(RowOut[ii].rgbRed*0.8);
   end;
  end;
end;
end;


procedure TFormScreen.FormCreate(Sender: TObject);
begin
 BT:=Tbitmap.Create;
 BT_tmp:=Tbitmap.Create;
 BT.PixelFormat:=pf32bit;
 BT_tmp.PixelFormat:=pf32bit;
 BT.Width:=width;
 bt.Height:=height;
 BT_tmp.Assign(bt);
 _shot:=false;
 isMouseDown:=false;
 draww:=false;
 redr:=true;
 ree.Left:=0;
 ree.Top:=0;
 ree.Right:=0;
 ree.Bottom:=0;
end;

procedure TFormScreen.Shotting;
var DCC:HDC; CenterPointY,CenterPointX:integer;
begin
BT_tmp.Width:=screen.Width;
BT_tmp.Height:=screen.Height;
CenterPointX:=(BT_tmp.Width div 2);
CenterPointY:=(BT_tmp.Height div 2);
ix:=CenterPointX-(CenterPointX div 24)*24;
iy:=CenterPointY-(CenterPointY div 24)*24;

ShowWindow(FormScreen.Handle,SW_Hide);
sleep(10);
DCC:=GetDC(0);
BitBlt(BT_tmp.Canvas.Handle,0,0,BT_tmp.Width,BT_tmp.Height,DCC,0,0,SrcCopy or $40000000);
ReleaseDC(0,DCC);
ShowWindow(FormScreen.Handle, SW_MAXIMIZE );
show;
bt.Assign(BT_tmp);
DrawBack;
end;

procedure TFormScreen.DrawBack;
begin
BitBlt(bt.canvas.Handle,0,0,BT.Width,BT.Height,BT_tmp.Canvas.Handle,0,0,SrcCopy);
DrawVisor(bt, rect(0,0,bt.width,bt.height));

if(draww) then begin
  bt.Canvas.Brush.Style:=bsclear;
  bt.Canvas.Pen.Color:=clred;
  bt.Canvas.Pen.Style:=psDash;
 // bt.Canvas.Pen.Width:=2; // -! :(
  bt.Canvas.Rectangle(ree);
end;

BitBlt(canvas.Handle,0,0,BT.Width,BT.Height,bt.Canvas.Handle,0,0,SrcCopy);
end;


procedure TFormScreen.bcloseClick(Sender: TObject);
begin
close;
end;

procedure TFormScreen.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  isMouseDown:=true;

  if (draww)and(InRect(x,y,ree.Left,ree.Top,ree.Right,ree.Bottom)) then begin
    redr:=false;

  end else begin
    redr:=true;
    draww:=false;
    if(IsButtOn) then begin
      ree.Left:=(x div 24)*24+ix;
      ree.Top:=(y div 24)*24+iy;
      ree.Right:=ree.Left;
      ree.Bottom:=ree.Top;
    end else begin
      ree.Left:=x;
      ree.Top:=y;
      ree.Right:=x;
      ree.Bottom:=y;
    end;
  end;
end;

procedure TFormScreen.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if(isMouseDown) then begin
  if (redr) then begin
   draww:=true;
   if not(IsButtOn) then begin
      ree.Right:=x;
      ree.Bottom:=y;
   end else begin
      ree.Right:=(x div 24)*24+ix+24;
      ree.Bottom:=(y div 24)*24+iy+24;
   end;
   DrawBack;
  end;
 end;
end;

procedure TFormScreen.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 isMouseDown:=false; redr:=false;
 if(draww) then bsave.Visible:=true else bsave.Visible:=false;
 DrawBack;  
end;

procedure TFormScreen.bsaveClick(Sender: TObject);
var btt:tbitmap; rree:trect;
begin
 rree:=ree;
 //  :)
 if(ree.Right<ree.Left) then begin
  rree.Left:=ree.Right;
  rree.Right:=ree.Left;
 end;
 if(ree.Bottom<ree.Top) then begin
  rree.Bottom:=ree.Top;
  rree.Top:=ree.Bottom;
 end;

 if(SD.Execute)and((rree.Right-rree.Left)>0)and((rree.Bottom-rree.Top)>0) then begin
   btt:=tbitmap.Create;
   try
    btt.Width:=rree.Right-rree.Left;
    btt.Height:=rree.Bottom-rree.Top;
    btt.Canvas.CopyRect( rect(0,0,btt.Width,btt.Height), bt_tmp.canvas , rree );
    if(lowercase(extractfileext(sd.FileName))='.bmp') then
     btt.SaveToFile(SD.FileName) else
     btt.SaveToFile(SD.FileName+'.bmp');
   finally
    btt.Free;
   end;
 end;
end;

procedure TFormScreen.FormPaint(Sender: TObject);
begin
BitBlt(canvas.Handle,0,0,BT.Width,BT.Height,bt.Canvas.Handle,0,0,SrcCopy);
end;

end.
